src/app/user/forms/__init__.py
from .changePassword import ChangePasswordform
from .changeStatus import ChangeStatusForm
from .changePersonal import ChangePersonalForm
from .changeAddress import ChangeAddressForm

src/app/user/forms/changeAddress.py
from flask_wtf import FlaskForm
from wtforms import StringField, SubmitField, PasswordField
from wtforms.validators import DataRequired, Regexp, EqualTo, Length


class ChangeAddressForm(FlaskForm):
    street = StringField('Ulice')
    house_number = StringField('Číslo popisné', validators=[DataRequired()])
    city = StringField('Město/Obec', validators=[DataRequired()])
    zip_code = StringField('PSČ', validators=[DataRequired(), Length(min=5, message="PSČ musí mít alespoň 5 čísel")])

    submit = SubmitField('Změnit Adresu')

src/app/user/forms/changePassword.py
from flask_wtf import FlaskForm
from wtforms import SubmitField, PasswordField
from wtforms.validators import DataRequired, EqualTo


class ChangePasswordform(FlaskForm):
    password = PasswordField('Heslo', validators=[DataRequired()])
    confirm_password = PasswordField('Potvrďte heslo', validators=[DataRequired(), EqualTo('password')])

    submit = SubmitField('Změnit heslo')

src/app/user/forms/changePersonal.py
from flask_wtf import FlaskForm
from wtforms import StringField, SubmitField, PasswordField
from wtforms.validators import DataRequired, Regexp, EqualTo, Length


class ChangePersonalForm(FlaskForm):
    first_name = StringField('Jméno', validators=[DataRequired()])
    last_name = StringField('Příjmení')
    telephone_number = StringField('Telefonní číslo', validators=[
        DataRequired(),
        Regexp(r'^(\+[0-9]{1,3})?( |-)?[0-9]{3}( |-)?[0-9]{3,4}( |-)?[0-9]{0,4}$')
    ])
    submit = SubmitField('Změnit')

src/app/user/forms/changeStatus.py
from flask_wtf import FlaskForm
from wtforms import SubmitField, RadioField


class ChangeStatusForm(FlaskForm):
    status_id = RadioField('Status', choices=[('1', 'čekající'), ('2', 'aktivní'), ('3', 'ban')])

    submit = SubmitField('Změnit')

src/app/admin/views.py
from flask import Blueprint, render_template, redirect, url_for, flash, request
from flask_login import login_required

from .forms import AddUserForm, ChangeRoleForm
from .services import UserListService
from .. import db
from ..decorators import permission_required
from ..models import User, PriceList, Address, Role, Permission
from ..user.forms import ChangeStatusForm
from ..user.forms.updatePriceList import UpdatePriceListForm

admin = Blueprint('admin', __name__)


@admin.route('/users')
@login_required
@permission_required(Permission.USER_ADMINISTRATION)
def view_users_page():
    filter_option = request.args.get('filter', None, str)
    users = UserListService.get(filter_option)

    return render_template("admin/users.jinja2", title="Přehled uživatelů", users=users)


@admin.route('/usersRole')
@login_required
@permission_required(Permission.CHANGE_ROLE)
def users_role_page():
    user_role_request = User.query.join(Role, Role.role_id == User.role_id).add_columns(User.user_id,
                                                                                        Role.role_id,
                                                                                        Role.name, User.first_name,
                                                                                        User.last_name,
                                                                                        User.login).all()
    return render_template("admin/userRole.jinja2", title=f"Přehled práv uživatelů",
                           user_role_request=user_role_request)


@admin.route('/users/add', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.ADD_WORKER)
def add_user_page():
    form = AddUserForm()

    if form.validate_on_submit():
        new_user = User(
            form.first_name.data,
            form.last_name.data,
            form.telephone_number.data,
            form.login.data,
            form.password.data,
        )
        address = Address(
            form.street.data,
            form.house_number.data,
            form.city.data,
            form.zip_code.data
        )
        new_user.permanent_residence = address
        db.session.add(new_user)
        db.session.commit()
        return redirect(url_for('auth.view_login_page'))

    return render_template('admin/addUser.jinja2', title='Nový uživatel', form=form)


@admin.route('/updatePrice/<int:id>', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.CHANGE_ROLE)
def update_price(id):
    form = UpdatePriceListForm()
    price_to_update = PriceList.query.get_or_404(id)
    if request.method == "POST":
        price_to_update.price = request.form['price']
        try:
            db.session.commit()
            return redirect(url_for('user.view_dashboard_page'))
        except:
            flash('Error')
            return render_template("user/updatePriceList.jinja2", form=form, price_to_update=price_to_update)
    return render_template("user/updatePriceList.jinja2", form=form, price_to_update=price_to_update)


@admin.route('/changeStatus/<int:id>', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.STATUS_CHANGING)
def change_status(id):
    form = ChangeStatusForm()
    status_to_change = User.query.get_or_404(id)
    if request.method == "POST":
        status_to_change.status_id = request.form['status_id']
        try:
            db.session.commit()
            flash('Změna statusu proběhla úspěšně')
            return render_template("user/changeStatus.jinja2", form=form, status_to_change=status_to_change)
        except:
            flash('Error')
            return render_template("user/changeStatus.jinja2", form=form, status_to_change=status_to_change)
    return render_template("user/changeStatus.jinja2", form=form, status_to_change=status_to_change)


@admin.route('/changeRole/<int:id>', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.CHANGE_ROLE)
def change_role(id):
    form = ChangeRoleForm()
    role_to_change = User.query.get_or_404(id)
    if request.method == "POST":
        role_to_change.role_id = request.form['role_id']
        try:
            db.session.commit()
            return redirect(url_for('admin.view_users_page'))
        except:
            flash('Error')
            return render_template("admin/changeRole.jinja2", form=form, role_to_change=role_to_change)
    return render_template("admin/changeRole.jinja2", form=form, role_to_change=role_to_change)

src/app/main/views.py
from flask import Blueprint, render_template, flash, redirect, url_for

from .forms.EditPriceForm import EditPriceForm
from .. import db
from ..blueprints.stats.services.statistics import Statistics
from ..models import PriceList

main = Blueprint('main', __name__)


@main.route('/')
def view_home_page():
    price_query = Statistics.get_price_list()
    data = {
        'stats': {
            'Noviny': 1200,
            'Železo': 980,
            'Měď': 375,
            'Hliník': 525,
            'Olovo': 692,
        },
        'prices': price_query
    }
    return render_template('main/homepage.jinja2', title='Domovská stránka', data=data)


@main.route('/greet')
def view_greeting_page():
    return render_template('main/greet.jinja2', title='Greeting', greeting='Hello')


@main.route('/prices')
def add_material_prices():
    price_query = Statistics.get_price_list()

    return render_template('main/price_list.jinja2', title='Ceník', prices_request=price_query)


@main.route('/prices/edit', methods=['GET', 'POST'])
def edit_material_price():
    form = EditPriceForm()

    if form.validate_on_submit():
        new_price = PriceList(form.opts.data.material_id, form.price.data)
        db.session.add(new_price)
        db.session.commit()
        flash("Cena materiálu byla úspešně aktualizována", 'success')
        return redirect(url_for('main.add_material_prices'))
    return render_template("main/EditPriceList.jinja2", form=form)

src/app/purchase/views.py
from flask import Blueprint, render_template, redirect, url_for
from flask_login import current_user, login_required
from sqlalchemy import desc

from .. import db
from ..admin.forms import AddPurchaseForm
from ..decorators import permission_required
from ..models import Permission, Purchase
from ..blueprints.stats.services.statistics import Statistics

purchase = Blueprint('purchase', __name__)


@purchase.route('/')
@login_required
def view_purchases_page():
    if current_user.is_administrator() or current_user.is_worker():
        purchases = Purchase.query.order_by(desc(Purchase.date)).all()
    else:
        purchases = Purchase.query \
            .filter_by(selling_customer_id=current_user.user_id) \
            .order_by(desc(Purchase.date)) \
            .all()

    return render_template("admin/purchases.jinja2", title=f"Přehled výkupů", purchases=purchases)


@purchase.route('/new', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.BUYING)
def view_add_purchase_page():
    form = AddPurchaseForm()

    # TODO: Change price
    if form.validate_on_submit():

        pList = Statistics.get_price_list()
        price = 0
        for item in pList:
            if item.name == form.material_id.data.name:
                price = item.price

        new_purchase = Purchase(
            form.weight.data,
            form.description.data,
            price*float(form.weight.data),
            form.material_id.data.material_id,
            current_user.user_id,
            form.selling_customer_id.data.user_id
        )
        db.session.add(new_purchase)
        db.session.commit()

        return redirect(url_for('purchase.view_purchases_page'))

    return render_template("admin/addPurchase.jinja2", title=f"Přehled výkupů",
                           form=form)


@purchase.route('<int:id>')
@login_required
def view_purchase_detail_page(id: int):
    found_purchase = Purchase.query.get_or_404(id)
    data = dict(purchase=found_purchase)
    return render_template('purchase/detail.jinja2', title='Detail výkupu', data=data)

src/app/user/__init__.py
from ..models import Material


def get_user_attributes(user):
    user_attributes = {

    }
    return user_attributes


def get_price_list():
    material = Material.query.all()

    return material

src/app/user/views.py
from flask import Blueprint, render_template, redirect, url_for, flash, abort
from flask_login import current_user, login_required
from sqlalchemy import desc

from . import get_user_attributes
from .forms import ChangePasswordform, ChangePersonalForm, ChangeAddressForm
from .. import db
from ..blueprints.stats.services.statistics import Statistics
from ..decorators import permission_required
from ..models import User, Permission, Purchase, UserStatus, Status, Address


user = Blueprint('user', __name__)


@user.route('/change/password', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.SELF_MANAGEMENT)
def view_change_password_page():
    form = ChangePasswordform()

    if form.validate_on_submit():
        current_user.password = form.password.data

        db.session.commit()

        flash('Změna hesla proběhla úspěšně')
        return redirect(url_for('auth.logout'))
    return render_template('user/changePassword.jinja2', title='zmena', form=form)


@user.route('<id>/settings', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.SELF_MANAGEMENT)
def view_change_personal_page(id):
    # Page is only accessible by workers and user it belongs to
    if not ((current_user.user_id == int(id)) or current_user.is_administrator() or current_user.is_worker()):
        abort(403)

    edited_user = User.query.get_or_404(id)

    form = ChangePersonalForm()

    if form.validate_on_submit():
        edited_user.first_name = form.first_name.data
        edited_user.last_name = form.last_name.data
        edited_user.telephone_number = form.telephone_number.data

        db.session.commit()

        flash('Změna údajů proběhla úspěšně')
        return redirect(url_for('user.view_dashboard_page'))

    return render_template('user/changePersonal.jinja2', title='zmena', form=form, user=edited_user)


@user.route('<id>/change/address/primary', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.SELF_MANAGEMENT)
def view_change_address_page(id):
    # Page is only accessible by workers and user it belongs to
    if not ((current_user.user_id == int(id)) or current_user.is_administrator() or current_user.is_worker()):
        abort(403)

    edited_user = User.query.get_or_404(id)

    form = ChangeAddressForm()
    if form.validate_on_submit():
        address = Address(
            form.street.data,
            form.house_number.data,
            form.city.data,
            form.zip_code.data
        )
        edited_user.permanent_residence = address
        db.session.add(address)
        db.session.commit()

        flash('Změna údajů proběhla úspěšně')
        return redirect(url_for('user.view_dashboard_page'))
    return render_template('user/changeAddress.jinja2', title='Změna adresy', form=form)


@user.route('<id>/change/address/secondary', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.SELF_MANAGEMENT)
def view_change_secondary_address_page(id):
    # Page is only accessible by workers and user it belongs to
    if not ((current_user.user_id == int(id)) or current_user.is_administrator() or current_user.is_worker()):
        abort(403)

    edited_user = User.query.get_or_404(id)

    form = ChangeAddressForm()
    if form.validate_on_submit():
        address = Address(
            form.street.data,
            form.house_number.data,
            form.city.data,
            form.zip_code.data
        )
        edited_user.temporary_residence = address
        db.session.add(address)
        db.session.commit()

        flash('Změna údajů proběhla úspěšně')
        return redirect(url_for('user.view_dashboard_page'))
    return render_template('user/changeSecondAddress.jinja2', title='Změna sekundární adresy', form=form)


@user.route('/dashboard')
@login_required
@permission_required(Permission.ACCESS)
def view_dashboard_page():
    user_attributes = get_user_attributes(current_user)
    price_list = Statistics.get_price_list()

    waiting_status = Status.query.filter_by(name=UserStatus.WAITING.value).first()

    registration_requests = User.query \
        .filter_by(status_id=waiting_status.status_id) \
        .order_by(User.user_id) \
        .limit(5) \
        .all()

    if current_user.is_administrator() or current_user.is_worker():
        purchases = Purchase.query. \
            filter_by(buying_employee_id=current_user.user_id) \
            .order_by(desc(Purchase.date)) \
            .limit(5) \
            .all()
    else:
        purchases = Purchase.query. \
            filter_by(selling_customer_id=current_user.user_id) \
            .order_by(desc(Purchase.date)) \
            .limit(5) \
            .all()
    stats = Statistics(current_user)
    total = stats.this_months_money()

    data = dict(user_attributes=user_attributes, registration_requests=registration_requests, price_list=price_list,
                purchases=purchases, total=total)
    return render_template("user/dashboard.jinja2", title=f"Přehled uživatele {current_user.login}", data=data)


@user.route('/<id>/confirm')
@login_required
@permission_required(Permission.USER_ADMINISTRATION)
def confirm_user(id):
    searched_user = User.query.get_or_404(id)
    if searched_user.status.name == UserStatus.WAITING.value:
        searched_user.confirm()
        db.session.commit()
        flash(f"Registrace uživatele {searched_user.login} potvrzena", 'success')
    return redirect(url_for('admin.view_users_page'))


@user.route('<id>/ban')
@login_required
@permission_required(Permission.USER_ADMINISTRATION)
def ban_user(id):
    searched_user = User.query.get_or_404(id)
    if searched_user.status.name == UserStatus.ACTIVE.value:
        searched_user.ban()
        db.session.commit()
        flash(f"Uživatel {searched_user.login} byl zablokován", 'warning')
    return redirect(url_for('admin.view_users_page'))


@user.route('<id>/unban')
@login_required
@permission_required(Permission.USER_ADMINISTRATION)
def unban_user(id):
    searched_user = User.query.get_or_404(id)
    if searched_user.status.name == UserStatus.BANNED.value:
        searched_user.unban()
        db.session.commit()
        flash(f"Uživatel {searched_user.login} byl odblokován", 'warning')
    return redirect(url_for('admin.view_users_page'))


@user.route('<id>')
@login_required
def view_profile_page(id: int):
    # Page is only accessible by workers and user it belongs to
    if not ((current_user.user_id == int(id)) or current_user.is_administrator() or current_user.is_worker()):
        abort(403)

    found_user = User.query.get_or_404(id)

    s = Statistics(found_user)
    stats = s.this_months_money()

    if found_user.is_administrator() or found_user.is_worker():
        purchases = Purchase.query. \
            filter_by(buying_employee_id=found_user.user_id) \
            .order_by(Purchase.purchase_id) \
            .limit(5) \
            .all()
    else:
        purchases = Purchase.query. \
            filter_by(selling_customer_id=found_user.user_id) \
            .order_by(Purchase.purchase_id) \
            .limit(5) \
            .all()

    data = dict(user=found_user, purchases=purchases, stats=stats)
    return render_template('user/profile.jinja2', data=data,
                           title=f"Profil {found_user.first_name} {found_user.last_name}")

src/app/templates/user/changeAddress.jinja2
{% extends '__base.jinja2' %}

{% block content %}
    <main>
    <h1>Změnit primární adresu</h1>
    <form action="#" method="POST">
        {{ form.hidden_tag() }}

        <p>Trvalé bydliště</p> <br>
        {{ form.street.label }}
        {{ form.street }}
        <br>

        {{ form.house_number.label }}
        {{ form.house_number }}
        <br>

        {{ form.city.label }}
        {{ form.city }}
        <br>

        {{ form.zip_code.label }}
        {{ form.zip_code }}
        <br>

        {{ form.submit() }}
    </form>
    </main>
{% endblock %} {# End of block content #}

src/app/templates/user/changePassword.jinja2
{% extends '__base.jinja2' %}

{% block content %}
    <main>
        <h1>Změna hesla</h1>
        <form action="#" method="POST">
            {{ form.hidden_tag() }}

            {{ form.password.label }}
            {{ form.password }}
            <br>

            {{ form.confirm_password.label }}
            {{ form.confirm_password }}
            <br>

            {{ form.submit() }}
        </form>
    </main>
{% endblock %} {# End of block content #}

src/app/templates/user/changePersonal.jinja2
{% extends '__base.jinja2' %}

{% block content %}
    <main>
        <div>
            <h1>Změna údajů uživatele {{ user.login }}</h1>
            <a href="{{ url_for('user.view_change_password_page') }}">
                <button class="secondary">Změnit heslo</button>
            </a>
            <a href="{{ url_for('user.view_change_address_page',id=user.user_id) }}">
                <button class="secondary">Změnit primární adresu</button>
            </a>
            <a href="{{ url_for('user.view_change_secondary_address_page', id=user.user_id) }}">
                <button class="secondary">Změnit sekundární adresu</button>
            </a>
            {% if current_user.is_administrator() %}
                <a href="{{ url_for('admin.change_role', id=user.user_id) }}">
                    <button class="secondary">Změnit roli</button>
                </a>
            {% endif %}


            <form action="#" method="POST">
                {{ form.hidden_tag() }}

                <h2>Základní informace</h2><br>
                {{ form.first_name.label }}
                {{ form.first_name }}
                <br>

                {{ form.last_name.label }}
                {{ form.last_name }}
                <br>

                {{ form.telephone_number.label }}
                {{ form.telephone_number }}
                <br>

                {{ form.submit() }}
            </form>
        </div>
    </main>
{% endblock %} {# End of block content #}

src/app/templates/user/changeSecondAddress.jinja2
{% extends '__base.jinja2' %}

{% block content %}
    <main>
    <h1>Změnit sekundární adresu</h1>
    <form action="#" method="POST">
        {{ form.hidden_tag() }}

        <p>Trvalé bydliště</p> <br>
        {{ form.street.label }}
        {{ form.street }}
        <br>

        {{ form.house_number.label }}
        {{ form.house_number }}
        <br>

        {{ form.city.label }}
        {{ form.city }}
        <br>

        {{ form.zip_code.label }}
        {{ form.zip_code }}
        <br>

        {{ form.submit() }}
    </form>
    </main>
{% endblock %} {# End of block content #}

src/app/templates/user/changeStatus.jinja2
{% extends '__base.jinja2' %}

{% block content %}
    <form action="#" method="POST">
        {{ form.hidden_tag() }}

        {{ form.status_id.label }}
        {{ form.status_id(value=status_to_change.status_id)}}
        <br>

        {{ form.submit }}
    </form>
{% endblock %} {# End of block content #}

src/app/templates/user/dashboard.jinja2
{% extends '__base.jinja2' %}

{% block content %}
    <main>
        {% if current_user.is_administrator() or current_user.is_worker() %}
            {# Dashboard for workers and admins #}
            <h1>Přehled {% if current_user.is_administrator() %}správce{% else %}
                pracovníka{% endif %} {{ current_user.login }}</h1>

            <section id="dashboard">
            <div id="registration-requests">
                <h2>Žádosti o registraci</h2>
                <div class="list">
                    {% for req in data.registration_requests %}
                        <div class="list--item">
                            <div class="list--item--text">
                                <a href="{{ url_for('user.view_profile_page', id=req.user_id) }}">{{ req.first_name }} {{ req.last_name }} </a>
                            </div>
                            <a class="list--item--right" href="{{ url_for('user.confirm_user', id=req.user_id) }}">
                                Potvrdit <span class="material-symbols-outlined">done</span>
                            </a>
                        </div>
                    {% endfor %}
                </div>

                <a href="{{ url_for('admin.view_users_page') }}?filter=waiting">
                    <button class="secondary">Přehled žádostí</button>
                </a>
            </div>
        {% else %}
            {# Dashboard for "normal" users #}
            <h1>Přehled uživatele {{ current_user.login }}</h1>
            <section id="dashboard">

            <div>
                <h2>Uživatelské statistiky</h2>
                <div class="tile-list">
                    <div class="tile">
                        <p class="tile--title">K vyplacení</p>

                        <p class="tile--value">{{ data.total[1] }} Kč</p>

                    </div>
                </div>
            </div>

        {% endif %}

        <div id="last-purchases">
            <h2>Moje poslední výkupy</h2>
            <div class="list">
                {% for purchase in data.purchases %}
                    <div class="list--item">
                        {% if current_user.is_administrator() or current_user.is_worker() %}
                            <div class="list--item--text">
                                <a href="{{ url_for('user.view_profile_page', id=purchase.selling_customer.user_id) }}">{{ purchase.selling_customer.first_name }} {{ purchase.selling_customer.last_name }}</a>
                                <p>{{ moment(purchase.date).format('DD. MM. YYYY') }}</p>
                            </div>
                            <div class="list--item--right">
                                {{ purchase.material.name }} ({{ purchase.weight }} Kg)
                            </div>
                        {% else %}
                            <div class="list--item--text">
                                <p>{{ purchase.material.name }}</p>
                                <p>{{ moment(purchase.date).format('DD. MM. YYYY') }}</p>
                            </div>
                            <div class="list--item--right">
                                ({{ purchase.weight }} Kg)
                            </div>
                        {% endif %}
                    </div>

                {% endfor %}
            </div>
            <a href="{{ url_for('purchase.view_purchases_page') }}">
                <button class="secondary">Přehled výkupů</button>
            </a>
            {% if current_user.is_administrator() or current_user.is_worker() %}
                <a href="{{ url_for('purchase.view_add_purchase_page') }}">
                    <button class="primary">Přidat výkup</button>
                </a>
            {% endif %}
        </div>


        <div id="price-list">
            <h2>Ceník</h2>
            <div class="list">
                {% for price in data.price_list %}
                    <div class="list--item">
                        <div class="list--item--text"><span>{{ price.name }}</span></div>
                        <div class="list--item--right"><span>{{ price.price }}&nbsp;Kč/Kg</span></div>
                    </div>
                {% endfor %}
            </div>
            {% if current_user.is_administrator() or current_user.is_worker() %}
                <a href="{{ url_for('main.edit_material_price') }}">
                    <button class="secondary">Upravit</button>
                </a>
            {% endif %}
            <a href="{{ url_for('main.add_material_prices') }}">
                <button class="secondary">Více</button>
            </a>
        </div>
        </section>
    </main>
{% endblock %} {# End of block content #}

src/app/templates/user/profile.jinja2
{% extends '__base.jinja2' %}

{% block content %}
    <main>
        <header id="profile-header">
            <div class="basic-info">
                <h1>{{ data.user.first_name }} {{ data.user.last_name }} <span
                        class="text-subtle">({{ data.user.login }})</span></h1>
                <p>{{ data.user.status.name }}, {{ data.user.role.name }}</p>
            </div>
            <div class="profile-controls">
                {% if current_user.is_administrator() or current_user.is_worker() %}
                    {% if data.user.is_waiting() %}
                        <a class="pill pill-success"
                           href="{{ url_for('user.confirm_user', id=data.user.user_id) }}"><span
                                class="button-description">Potvrdit</span>
                            <span
                                    class="material-symbols-outlined">done</span></a>
                    {% elif data.user.is_active() %}
                        <a class="pill pill-error" href="{{ url_for('user.ban_user', id=data.user.user_id) }}"><span
                                class="button-description">Ban</span><span
                                class="material-symbols-outlined">cancel</span></a>
                    {% elif data.user.is_banned() %}
                        <a class="pill pill-warning"
                           href="{{ url_for('user.unban_user', id=data.user.user_id) }}"><span
                                class="button-description">Unban</span><span
                                class="material-symbols-outlined">restart_alt</span></a>
                    {% endif %}
                {% endif %}
                <a href="{{ url_for('user.view_change_personal_page', id=data.user.user_id) }}">
                    <button class="secondary">Změnit údaje</button>
                </a>

            </div>
        </header>
        <section id="profile-info">
            <section id="user-info">
                <h2>Kontakt</h2>
                <p><span class="material-symbols-outlined">call</span> {{ data.user.telephone_number }}</p>
                <p><span
                        class="material-symbols-outlined">home</span> {{ data.user.permanent_residence.street }} {{ data.user.permanent_residence.house_number }}<br> {{ data.user.permanent_residence.city }}<br>{{ data.user.permanent_residence.zip_code }}
                </p>
                {% if data.user.temporary_residence %}
                    <p><span
                            class="material-symbols-outlined">other_houses</span> {{ data.user.temporary_residence.street }} {{ data.user.temporary_residence.house_number }}<br> {{ data.user.temporary_residence.city }}<br>{{ data.user.temporary_residence.zip_code }}
                    </p>
                {% endif %}

            </section>
            {% if not (data.user.is_administrator() or data.user.is_worker()) %}
                {% if data.stats %}
                    <section id="stats">
                        <h2>Statistiky</h2>
                        <div class="tile-list">
                            <div class="tile">
                                <p class="tile--title">K vyplacení</p>

                                <p class="tile--value">{{ data.stats[1] }} Kč</p>

                            </div>
                        </div>

                    </section>
                {% endif %}
            {% endif %}
            <section id="last-purchases">
                {% if data.purchases %}
                    {% if data.user.is_administrator() or data.user.is_worker() %}
                        <h2>Odkupy provedené tímto pracovníkem</h2>
                    {% else %}
                        <h2>Poslední sběry uživatele</h2>
                    {% endif %}
                    {% for purchase in data.purchases %}
                        <div class="list--item">
                            {% if data.user.is_administrator() or data.user.is_worker() %}
                                <div class="list--item--text">
                                    <a href="{{ url_for('user.view_profile_page', id=purchase.selling_customer.user_id) }}">{{ purchase.selling_customer.first_name }} {{ purchase.selling_customer.last_name }}</a>
                                    <p>{{ moment(purchase.date).format('DD. MM. YYYY') }}</p>
                                </div>
                                <div class="list--item--right">
                                    {{ purchase.material.name }} ({{ purchase.weight }} Kg)
                                </div>
                            {% else %}
                                <div class="list--item--text">
                                    <a href="{{ url_for('purchase.view_purchase_detail_page', id=purchase.purchase_id) }}">
                                        {{ purchase.material.name }} {{ purchase.weight }} Kg</a>
                                    <p>{{ moment(purchase.date).format('DD. MM. YYYY') }}</p>
                                </div>
                                <div class="list--item--right">
                                    {{ purchase.price }} Kč
                                </div>
                            {% endif %}
                        </div>

                    {% endfor %}
                {% endif %}
            </section>
        </section>
    </main>
{% endblock %}